// ConsoleShutdownManager.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "ConsoleShutdownManager.h"
#include "con_res.h"
#include "con_draw.h"
#include <Windows.h>
#include <Winsvc.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// Global variable


// Function Extern
int		MainMenu();
void    ShowUsage();
void	ShowCopyright();
int		ExecUserAction( int iIndexCommand );
void	OpenConfigDlg();
void	GetSSDConsoleBinaPath ( char* pDir, int size );


void	StartServices ();
void	StopServices ();


// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		_tprintf(_T("Fatal Error: MFC initialization failed\n"));
		nRetCode = 1;
	}
	else
	{
		// TODO: code your application's behavior here.
		
		MainMenu ();

		return 0;
	}

	return nRetCode;
}




// ------------------------------------------------------------
//	int MainLoop()
//	Main Menu Loop Function
// ------------------------------------------------------------
//
int MainMenu()
{
	char	szInput[512];
	int		iIndexCommand;

	while(1)
	{
		DrawTitleWithDeck( g_szStrings[CONSOLE_MAIN_TITLE], TRUE );
		ShowUsage();
		DrawCommonItem( 0, NULL, TRUE );

		// Get User input
		while( 1 )
		{
			DrawCommonItem( 1, g_szStrings[CONSOLE_SELECT_NUM], FALSE );
			memset( szInput, 0x00, sizeof(szInput) );
			con_MyGets( szInput );
			iIndexCommand = GetInpuId( szInput );
			if ( iIndexCommand < 0 || iIndexCommand > 4 )
			{
				DrawCommonItem( 1, g_szInputError, TRUE );
				conGetAnyKeyActive();
			}
			else
			{
				break;
			}
		}

		// Exec User Command
		if ( iIndexCommand ==  CONSOLE_QUIT )
			return 0;
		else
			ExecUserAction( iIndexCommand );
	}
	return 1;
}



// --------------------------------------------------------------------------
//	int ExecUserAction()
//	Start Services, Stop Services, Show Configuration, Show version
// --------------------------------------------------------------------------
//
int ExecUserAction( int iIndexCommand )
{
	switch( iIndexCommand )
	{
	case CONSOLE_AGENT_START:
		StartServices();
		DrawCommonItem(0, NULL, TRUE);
		DrawCommonItem(1, g_szStrings[CONSOLE_START_MESSAGE], TRUE);
		DrawCommonItem(0, NULL, TRUE);
		break;
	case CONSOLE_AGENT_STOP:
		StopServices();
		DrawCommonItem(0, NULL, TRUE);
		DrawCommonItem(1, g_szStrings[CONSOLE_STOP_MESSAGE], TRUE);
		DrawCommonItem(0, NULL, TRUE);
		break;
	case CONSOLE_CONFIGURATION:
		OpenConfigDlg();
		break;
	case CONSOLE_VERSION_INFO:
		ShowCopyright();
		break;
	}

	return 0;
}


// --------------------------------------------------------------------------
//	int ExecUserAction()
//	Start Services, Stop Services, Show Configuration, Show version
// --------------------------------------------------------------------------
//
void	StartServices ()
{
	SC_HANDLE		hSCManager, hService;
	SERVICE_STATUS	ssStatus;

	hSCManager = OpenSCManager (NULL, NULL, SC_MANAGER_CONNECT);

	if ( !hSCManager )
	{
		return;
	}
	hService = OpenService (hSCManager, SZSERVICENAME, SERVICE_START|SERVICE_QUERY_STATUS);
	if ( !hService )
	{
		CloseServiceHandle(hSCManager);
		return;
	}
	do
	{
		Sleep(500);
		QueryServiceStatus (hService, &ssStatus);
	} while (	(ssStatus.dwCurrentState==SERVICE_START_PENDING) ||
		(ssStatus.dwCurrentState==SERVICE_STOP_PENDING) );

	if ( StartService(hService, 0, NULL) )
	{
		do
		{
			Sleep(500);
			QueryServiceStatus (hService,&ssStatus);
		} while(ssStatus.dwCurrentState == SERVICE_START_PENDING);
	}
	CloseServiceHandle (hService);
	CloseServiceHandle (hSCManager);
}


// --------------------------------------------------------------------------
//	int ExecUserAction()
//	Start Services, Stop Services, Show Configuration, Show version
// --------------------------------------------------------------------------
//
void	StopServices ()
{
	SC_HANDLE	hSCManager, hService;
	SERVICE_STATUS ssStatus;

	hSCManager = OpenSCManager (NULL,NULL,SC_MANAGER_CONNECT);

	if ( !hSCManager )
	{
		return ;
	}
	hService = OpenService (hSCManager,SZSERVICENAME,SERVICE_STOP|SERVICE_QUERY_STATUS);
	if ( !hService )
	{
		CloseServiceHandle(hSCManager);
		return ;
	}
	do
	{
		Sleep(500);
		QueryServiceStatus (hService,&ssStatus);
	} while (	(ssStatus.dwCurrentState==SERVICE_START_PENDING) ||
		(ssStatus.dwCurrentState==SERVICE_STOP_PENDING) );

	if ( ControlService (hService,SERVICE_CONTROL_STOP,&ssStatus) )
	{
		int iTime = 0;
		do
		{
			if ( iTime++ > 5 )
				break;
			Sleep(500);
			QueryServiceStatus (hService,&ssStatus);
		} while (ssStatus.dwCurrentState != SERVICE_STOPPED );
	}
	CloseServiceHandle (hService);
	CloseServiceHandle (hSCManager);
}



// ------------------------------------------------------------
//	void ShowUsage()
//	Show Main Menu
// ------------------------------------------------------------
//
void    ShowUsage()
{
	DrawCommonItem( 1, g_szStrings[CONSOLE_AGENT_START], TRUE );
	DrawCommonItem( 1, g_szStrings[CONSOLE_AGENT_STOP], TRUE );
	DrawCommonItem( 1, g_szStrings[CONSOLE_CONFIGURATION], TRUE );
	DrawCommonItem( 1, g_szStrings[CONSOLE_VERSION_INFO], TRUE );
	DrawCommonItem( 1, g_szStrings[CONSOLE_QUIT], TRUE );
}



// --------------------------------------------------------------------------
//	void ShowCopyright()
//	Show software Copyright
// --------------------------------------------------------------------------
//
void  ShowCopyright()
{
	DrawTitleWithDeck( g_szStrings[CONSOLE_VERSION_COPYRIGHT], TRUE );
	DrawCommonItem( 1, g_szStrings[CONSOLE_VERSION_NUM], TRUE );
	DrawCommonItem( 0, NULL, TRUE);
	DrawCommonItem( 0, NULL, TRUE);
	DrawCommonItem( 1, g_szStrings[CONSOLE_KEY_ANY], TRUE );
	conGetAnyKeyActive();
}



// --------------------------------------------------------------------------
//	void OpenConfigDlg()
//	Open Configuration dialog
// --------------------------------------------------------------------------
//
void OpenConfigDlg()
{
	char szTemp[MAX_PATH];
	char szBuff[MAX_PATH];

	memset(szTemp, 0x00, sizeof(szTemp));
	memset(szBuff, 0x00, sizeof(szBuff));

	GetSSDConsoleBinaPath ( szTemp, MAX_PATH );
	sprintf(szBuff, "\"%s\"", szTemp);
	system(szBuff);
}


// --------------------------------------------------------------------------
//	void GetSSDConsoleBinaPath()
//	get binary path
// --------------------------------------------------------------------------
//
void GetSSDConsoleBinaPath ( char* pDir, int size )
{
	size_t i = 0;
	if(GetModuleFileName(NULL,pDir,size))
	{
		for(i=strlen(pDir); i>=0; i--)
		{
			if(pDir[i] == '\\')
			{
				break;
			}
		}

		pDir[i+1] = 0;
		strcat(pDir, CONFIG_CONSOLE_BIN_NAME);
	}
}