#include "Stdafx.h"
#include "ttymodes.h"
#include <io.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include "con_draw.h"

const char g_szDeckBuffer[] = 
	{"+-----------------------------------------------------------------------------+"};

#define  CONSOLELENGTH ((int)(strlen(g_szDeckBuffer)))

int DrawTitleWithDeck(const char *szTitle, BOOL bCR)
{
	char szTemp[1024];
	int i;
	int nBlackLength;
	memset(szTemp, 0, sizeof(szTemp));
	sprintf(szTemp, "\n%s\n|", g_szDeckBuffer);
	nBlackLength = (CONSOLELENGTH - 2 - (int)strlen(szTitle)) / 2;
	for (i = 0; i < nBlackLength; i ++)
		strcat(szTemp, " ");
	strcat(szTemp, szTitle);
	for (i = 0; i < CONSOLELENGTH - 2 - (int)(strlen(szTitle)) - nBlackLength; i ++)
		strcat(szTemp, " ");
	if (bCR)
	{
		strcat(szTemp, "|\n");
		strcat(szTemp, g_szDeckBuffer);
		strcat(szTemp, "\n");
	}
	else
	{
		strcat(szTemp, "|\n");
		strcat(szTemp, g_szDeckBuffer);
	}
	printf("%s\n", szTemp);
	return 0;
}

int DrawCommonItem(int nTabBlack, const char *szBuff, BOOL bCR)
{
	char szTemp[256];
	int i;
	memset(szTemp, 0, sizeof(szTemp));
	for (i = 0; i < nTabBlack; i ++)
		strcat(szTemp, "   ");
	if (bCR)
	{	
		if (szBuff)
			strcat(szTemp, szBuff);
		strcat(szTemp, "\n");
	}
	else
	{
		if (szBuff)
			strcat(szTemp, szBuff);
	}
	printf(szTemp);
	return 0;
}

void con_MyGets(char *szInPut)
{
	int i;
	char c;
	int nNum = 0;
	fflush(stdout);
#ifdef WIN32
	while((i = _read(STDIN_FILENO, &c, 1)) == 1)
#else
	while((i = read(STDIN_FILENO, &c, 1)) == 1)
#endif
	{
		c &= 255;
		if(c == '\n')
			break;
		szInPut[nNum] = c;
		nNum ++;	
	}
	fflush(stdout);
	if (strlen(szInPut) == 0)
	{
		//strcpy(szInPut, "wrong input!!!!!");
		memset(szInPut, 0, sizeof(szInPut));
	}
}


#if defined(WIN32)
	char con_getch(void)
	{
		return _getch();
	}

#elif defined(CSS_MAC) || defined(CSS_SUN)

	char con_getch(void)
	{
		int ch = '\0';
		struct termios org_opts, new_opts;
		//----- store old settings -----------
		int res = 0;

		#if defined(PA_SUN)
			getretry:
		#endif

		res = tcgetattr(STDIN_FILENO, &org_opts);
		if (res < 0)
		{
			return 0;
		}

		//---- set new terminal parms --------
		memcpy(&new_opts, &org_opts, sizeof(new_opts));
		new_opts.c_lflag &= ~(ICANON | ECHO | ECHOE | ECHOK | ECHONL | ECHOPRT | ECHOKE | ICRNL);

		#ifdef PA_SUN
			new_opts.c_cc[VTIME] = 0;
			new_opts.c_cc[VMIN] = 1;
		#endif

		res = tcsetattr(STDIN_FILENO, TCSANOW, &new_opts);
		if (res)
		{
			return 0;
		}

		ch = getchar();

		//------ restore old settings ---------
		res = tcsetattr(STDIN_FILENO, TCSANOW, &org_opts);

		#if defined(PA_SUN)
			if (ch == -1)
			{
				goto getretry;
			}
		#endif

		return ch;
	}

#else
	char con_getch(void)
	{
		int ch = '\0';
		fflush(stdout);
		if(tty_cbreak(STDIN_FILENO) < 0)
		{
			fn_log(con_getch, param("tty_cbreak error"));
		}
		else
		{
			read(1, &ch, 1);
			tty_reset(STDIN_FILENO);
		}

		return ch;
	}
#endif
char conGetAnyKeyActive()
{
	return con_getch();
}

int GetInpuId(const char *szInput)
{
	int nInput = 0;
	char szBuff[MAX_PATH];
	nInput = atoi(szInput);

	memset(szBuff, 0, MAX_PATH);
	sprintf(szBuff, "%d", nInput);
	if (strcmp(szInput, szBuff) != 0 || nInput < 0)
		nInput = -1;
	return nInput;
}

int IntToString(int nNum, char *pszBuff)
{
	char szBuff[MAX_PATH];
	memset(szBuff, 0, MAX_PATH);
	sprintf(szBuff, "%d", nNum);
	strcpy(pszBuff, szBuff);
	return 0;
}

int FormatBlank(const char *szBuff, char *pszBuff)
{
	int i;
	char szTemp[1024];
	memset(szTemp, 0, sizeof(szTemp));
	for (i = 0; i < 55 - (int)(strlen(szBuff)); i ++)
	{
		strcat(szTemp, " ");
	}
	strcpy(pszBuff, szTemp);
	return 0;
}

int ClearWindows()
{
	system("cls");
	return 0;
}
