// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ShutdownManager.h"
#include "MainFrm.h"
#include "..\Protocol.h"
#include "AboutDlg.h"
#include <WinSvc.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

BOOL GetConfigExePath(char *pszFileName)
{
	int		i = 0;
	int		nSize = 512;
	char	szPath[512];

	memset(szPath, 0, sizeof(szPath));

	if(GetModuleFileName(NULL, szPath, nSize))
	{
		for(i=(int)_tcslen(szPath); i>=0; i--)
		{
			if(szPath[i] == '\\')
			{
				break;
			}
		}
		szPath[i+1] = 0;

		strcat_s(szPath, (512-i-1), CONFIGSDPARA_FILENAME);

		if(pszFileName != NULL)
		{
			strcpy_s(pszFileName, 512, szPath);
		}

		return TRUE;
	}

	return FALSE;
}


// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_COMMAND(ID_POP_CONFIGURATION, &CMainFrame::OnTrayConfig)
	ON_COMMAND(ID_POP_EXIT, &CMainFrame::OnTrayExit)
	ON_COMMAND(ID_POP_ABOUT, &CMainFrame::OnTrayAbout)
	ON_COMMAND(ID_POP_START, &CMainFrame::OnTrayStart)
	ON_COMMAND(ID_POP_STOP, &CMainFrame::OnTrayStop)
	ON_UPDATE_COMMAND_UI(ID_POP_START, &CMainFrame::OnUpdateStartAgent)
	ON_UPDATE_COMMAND_UI(ID_POP_STOP, &CMainFrame::OnUpdateStopAgent)
	ON_UPDATE_COMMAND_UI(ID_POP_CONFIGURATION, &CMainFrame::OnUpdateConfiguration)	//imachine added 2010.08.24, set configuration item status
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame():m_bICONExist(FALSE)
{
	// TODO: add member initialization code here
	m_bServiceRun = FALSE;
	m_bOmronCommand = TRUE;	//imachine added 2010.08.24, set configuration item status
	memset(&m_ShutdownParam,0,sizeof(m_ShutdownParam));
	memset(&m_AMData,0,sizeof(m_AMData));
}

CMainFrame::~CMainFrame()
{
}
void Substitute(char *pInput, char *pOutput, char *pSrc, char *pDst)
{
	char *pi = NULL;
	char *po = NULL;
	char *p = NULL;
	size_t nSrcLen = 0;
	size_t nDstLen = 0;
	size_t nLen = 0;
	pi = pInput;
	po = pOutput;
	nSrcLen = strlen(pSrc);
	nDstLen = strlen(pDst); 
	p = strstr(pi, pSrc);
	if(p)
	{
		while(p)
		{
			nLen = (int)(p - pi);
			memcpy(po, pi, nLen);
			memcpy(po + nLen, pDst, nDstLen);
			pi = p + nSrcLen;
			po = po + nLen + nDstLen;
			p = strstr(pi, pSrc);
		}
		strcpy(po, pi);
	}
	else
	{
		strcpy(po, pi);
	}
}
BOOL CMainFrame::ChangeICONStatus(DWORD dwMsg)
{
	BYTE			imgIndexStatus = IDI_UPS_NORMAL;
	BYTE			byCommSt = UPSNOTFND, byBattSt = UPSNOTFND, byUPSSt = UPSNOTFND;
	CString			csTotal, csComm, csUPS, csBatt;
	NOTIFYICONDATA	tnid;
	int				iWarningStatus = 0;
	BYTE			byStatus = 0;
	size_t		i = 0;
	size_t		nSize = MAX_PATH;
	char	szFileName[MAX_PATH] = {0};
	FILE * fp = NULL;
	char szTemp[512];
	char szBuff[512];
	char szString[512];

	CMenu*	pSubMenu;

	pSubMenu = m_menuTray.GetSubMenu(0);


	tnid.cbSize = sizeof(NOTIFYICONDATA);
	tnid.hWnd	= m_hWnd;
	tnid.uID	= 0;
	tnid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	tnid.uCallbackMessage = WM_NOTIFYICON;

	switch(m_AMData.iACFailStatus) 
	{
	case ACFAILSTATUS_NONE:
		csTotal.LoadString(GetStatusStringID(UPSNOAGENT));
		m_bServiceRun = FALSE;
		m_bOmronCommand = TRUE;	//imachine added 2010.08.24, set configuration item status
		tnid.hIcon = ((CShutdownManagerApp*)AfxGetApp())->LoadIcon(MAKEINTRESOURCE(IDI_UPS_STOP));
		lstrcpyn(tnid.szTip, (LPCTSTR)csTotal, sizeof(tnid.szTip));
		return Shell_NotifyIcon(dwMsg, &tnid);

	case UPSSTATUS_COMLST:
		m_bServiceRun = TRUE;
		m_bOmronCommand = TRUE;	//imachine added 2010.08.24, set configuration item status
		imgIndexStatus = IDI_UPS_WARNING;
		break;

	case UPSSTAUTS_COMEST:
		m_bServiceRun = TRUE;
		m_bOmronCommand = TRUE;	//imachine added 2010.08.24, set configuration item status
		imgIndexStatus = IDI_UPS_NORMAL;
		byCommSt = UPSCOMEST;
		byUPSSt = UPSNORMAL;
		byBattSt = BATNORMAL;
		break;

	case UPSSTATUS_BATTLOW:
		m_bServiceRun = TRUE;
		m_bOmronCommand = TRUE;	//imachine added 2010.08.24, set configuration item status
		imgIndexStatus = IDI_UPS_SERIOUS;
		byCommSt = UPSCOMEST;
		byUPSSt = UPSNORMAL;
		byBattSt = UPSBATLOW;
		break;

	case ACFAILSTATUS_ACFAIL:
		m_bServiceRun = TRUE;
		m_bOmronCommand = TRUE;	//imachine added 2010.08.24, set configuration item status
		imgIndexStatus = IDI_UPS_SERIOUS;
		byCommSt = UPSCOMEST;
		byUPSSt = UPSACFAIL;
		byBattSt = BATNORMAL;
		break;
	case UPSSTATUS_SD_OS_UPS_BY_OMRON:
		m_bServiceRun = TRUE;
		m_bOmronCommand = FALSE;	//imachine added 2010.08.24, set configuration item status
		imgIndexStatus = IDI_UPS_SERIOUS;
		byCommSt = UPSCOMEST;
		byUPSSt = UPSACFAIL;
		byBattSt = SD_OS_UPS_BY_OMRON;
		break;
	case UPSSTATUS_SD_OS_RESTART_LATER_BY_OMRON:
		m_bServiceRun = TRUE;
		m_bOmronCommand = FALSE;	//imachine added 2010.08.24, set configuration item status
		imgIndexStatus = IDI_UPS_SERIOUS;
		byCommSt = UPSCOMEST;
		byUPSSt = UPSACFAIL;
		byBattSt = RESTART_OS_LATER_BY_OMRON;
		break;
	case UPSSTATUS_ONLY_SD_OS_BY_OMRON:
		m_bServiceRun = TRUE;
		m_bOmronCommand = FALSE;	//imachine added 2010.08.24, set configuration item status
		imgIndexStatus = IDI_UPS_SERIOUS;
		byCommSt = UPSCOMEST;
		byUPSSt = UPSACFAIL;
		byBattSt = ONLY_SD_OS_BY_OMRON;
		break;

	default:
		return FALSE;
	}

	csComm.LoadString(GetStatusStringID(byCommSt));
	csBatt.LoadString(GetStatusStringID(byBattSt));
	csUPS.LoadString(GetStatusStringID(byUPSSt));

	if ( byCommSt == UPSCOMEST )
	{
		csTotal = csUPS + (CString)" " + csBatt;
	}
	else if(byCommSt == UPSNOTFND)
	{
		csTotal = csComm;
	}
	else
	{
		csTotal = csUPS + (CString)" " + csComm + (CString)" " + csBatt;
	}

	if (UPSSTATUS_SD_OS_UPS_BY_OMRON == m_AMData.iACFailStatus) 
	{
		csTotal.LoadString(GetStatusStringID(byBattSt));
	}
	else if (UPSSTATUS_SD_OS_RESTART_LATER_BY_OMRON == m_AMData.iACFailStatus) 
	{
		memset(szTemp, 0x00, sizeof(szTemp));
		
		if(GetModuleFileName(NULL, szFileName, (DWORD)nSize))
		{
			for(i=strlen(szFileName); i>=0; i--)
			{
				if(szFileName[i]== '\\')
					break;
			}
			
			szFileName[i+1] = 0;
			
			strcat(szFileName, "omronctl.ini");
		}
		fp = fopen(szFileName, "r");
		if (NULL != fp)
		{
			memset(szTemp, 0x00, sizeof(szTemp));
			fread(szTemp, sizeof(szTemp), 1, fp);
			fclose(fp);
			fp = NULL;
		}

		csTotal.LoadString(GetStatusStringID(byBattSt));
		memset(szBuff, 0x00, sizeof(szBuff));
		strcpy(szBuff, csTotal.GetBuffer());
		csTotal.ReleaseBuffer();
		memset(szString, 0x00, sizeof(szString));
		Substitute(szBuff, szString, "%1", szTemp);
		csTotal = szString;
	}
	else if (UPSSTATUS_ONLY_SD_OS_BY_OMRON == m_AMData.iACFailStatus) 
	{
		csTotal.LoadString(GetStatusStringID(byBattSt));
	}

	tnid.hIcon	= ((CShutdownManagerApp*)AfxGetApp())->LoadIcon(MAKEINTRESOURCE(imgIndexStatus));
	lstrcpyn(tnid.szTip, (LPCTSTR)csTotal, sizeof(tnid.szTip));
	return Shell_NotifyIcon(dwMsg, &tnid);
}

UINT CMainFrame::GetStatusStringID(BYTE byStatus)
{
	switch ( byStatus )
	{ 
	case UPSNORMAL:
		return IDS_UPSNORMAL;
	case BATNORMAL:
		return IDS_BATNORMAL;
	case UPSCOMEST:
		return IDS_UPSCOMSET;
	case UPSNOTFND:
		return IDS_UPSNOTFND;
	case UPSACFAIL:
		return IDS_UPSACFAIL;
	case UPSBATLOW:
		return IDS_UPSBATLOW;
	case UPSNOAGENT:
		return IDS_UPSNOAGENT;
	case SD_OS_UPS_BY_OMRON:
		return IDS_SD_OS_UPS_BY_OMRON;
	case ONLY_SD_OS_BY_OMRON:
		return IDS_ONLY_SD_OS_BY_OMRON;
	case RESTART_OS_LATER_BY_OMRON:
		return IDS_RESTART_OS_LATER_BY_OMRON;
	default:
		return IDS_UPSNORMAL;
	}
}

LRESULT CMainFrame::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	BOOL	bRet;
	char	*pszBuf = NULL;
	int		iCount = 0;
	HANDLE	hFileMap = NULL, hMutex = NULL;

	BYTE byBattSt = UPSNOTFND, byUPSSt = UPSNOTFND, byCommSt = UPSNOTFND;
	UINT uMsg = RegisterWindowMessage(_T("Exit"));

	if (( message == uMsg )
	 ||( message == WM_CLOSE ))
	{
		KillTimer(0);
		ChangeICONStatus(NIM_DELETE);
		PostMessage(WM_QUIT, 0, 0);
	}

	switch ( message )
	{
	case WM_TIMER:
		{
			if(wParam == 0)
			{
				hFileMap = OpenFileMapping(
					FILE_MAP_READ,
					FALSE,
					UPSSTATUSSHMNAME);

				hMutex = OpenMutex(
					MUTEX_ALL_ACCESS,
					FALSE,
					UPSSTATUSSYNCFILEMAPPING);

				if ( (hFileMap == NULL) || (hMutex == NULL) )
				{
					memset(&m_AMData, 0, sizeof(m_AMData));

					if(m_bICONExist)
					{
						ChangeICONStatus(NIM_MODIFY);
					}
					else
					{
						bRet = ChangeICONStatus(NIM_ADD);
						m_bICONExist = bRet ? TRUE : FALSE;
					}

					if ( hFileMap )
					{
						CloseHandle(hFileMap);
					}

					if ( hMutex )
					{
						CloseHandle(hMutex);
					}

					return TRUE;
				}

				iCount = 0;
				while(iCount++ < 5) // Time out is 500 ms.
				{
					if ( WaitForSingleObject(hMutex, 100) == WAIT_OBJECT_0 )
					{
						pszBuf = (char*)MapViewOfFile(hFileMap, 
							FILE_MAP_READ,
							0, 0,	0);
						if ( pszBuf == NULL )
						{
							ReleaseMutex(hMutex);
							break;
						}

						memcpy(&m_AMData, pszBuf, sizeof(m_AMData));
						UnmapViewOfFile(pszBuf);
						ReleaseMutex(hMutex);
						pszBuf = NULL;

						if(m_bICONExist)
						{
							ChangeICONStatus(NIM_MODIFY);
						}
						else
						{
							bRet = ChangeICONStatus(NIM_ADD);							
							m_bICONExist = bRet ? TRUE : FALSE;
						}
						break;
					}
				}

				CloseHandle(hFileMap);
				CloseHandle(hMutex);
			}
		}
		break;

	case WM_NOTIFYICON:
		if (lParam == WM_RBUTTONDOWN)
		{
			POINT point;
			GetCursorPos(&point);

			CMenu*	pSubMenu;

			SetForegroundWindow();

			pSubMenu = m_menuTray.GetSubMenu(0);
			
			pSubMenu->TrackPopupMenu(
				TPM_RIGHTALIGN|TPM_BOTTOMALIGN,
				point.x,
				point.y, 
				this,
				NULL); // route commands through main window
			ShowWindow(SW_MINIMIZE);
			ShowWindow(SW_HIDE);
		}
		break;
	}

	return CFrameWnd::WindowProc(message, wParam, lParam);
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_menuTray.LoadMenu(IDR_MENU_TRAY);

	SetTimer(0, 1000, NULL);
	return 0;
}

void CMainFrame::OnClose() 
{
	CFrameWnd::OnClose();
}

void CMainFrame::OnTrayExit()
{		
	SendMessage(WM_CLOSE);
}

void CMainFrame::OnTrayConfig()
{
	char csFileName[512];
	memset(csFileName, 0, sizeof(csFileName));
	GetConfigExePath(csFileName);
	ShellExecute(NULL, "open", csFileName, "", NULL, SW_SHOWNORMAL);
}

BOOL g_bAboutExist = TRUE;
void CMainFrame::OnTrayAbout()
{
	// TODO: Add your command handler code here
	if( g_bAboutExist )
	{
		g_bAboutExist = FALSE;

		SetForegroundWindow();

		CAboutDlg dlg;
		dlg.DoModal();

		g_bAboutExist = TRUE;
	}
}
 
void CMainFrame::OnTrayStart()
{
	SC_HANDLE		hSCManager, hService;
	SERVICE_STATUS	ssStatus;

	hSCManager = OpenSCManager (NULL, NULL, SC_MANAGER_CONNECT);

	if ( !hSCManager )
	{
		return;
	}
	hService = OpenService (hSCManager, SZSERVICENAME, SERVICE_START|SERVICE_QUERY_STATUS);
	if ( !hService )
	{
		CloseServiceHandle(hSCManager);
		return;
	}
	do
	{
		Sleep(500);
		QueryServiceStatus (hService, &ssStatus);
	} while (	(ssStatus.dwCurrentState==SERVICE_START_PENDING) ||
		(ssStatus.dwCurrentState==SERVICE_STOP_PENDING) );

	if ( StartService(hService, 0, NULL) )
	{
		do
		{
			Sleep(500);
			QueryServiceStatus (hService,&ssStatus);
		} while(ssStatus.dwCurrentState == SERVICE_START_PENDING);
	}
	CloseServiceHandle (hService);
	CloseServiceHandle (hSCManager);

	m_bServiceRun = TRUE;
}
void CMainFrame::OnTrayStop()
{
	SC_HANDLE	hSCManager, hService;
	SERVICE_STATUS ssStatus;

	hSCManager = OpenSCManager (NULL,NULL,SC_MANAGER_CONNECT);

	if ( !hSCManager )
	{
		return ;
	}
	hService = OpenService (hSCManager,SZSERVICENAME,SERVICE_STOP|SERVICE_QUERY_STATUS);
	if ( !hService )
	{
		CloseServiceHandle(hSCManager);
		return ;
	}
	do
	{
		Sleep(500);
		QueryServiceStatus (hService,&ssStatus);
	} while (	(ssStatus.dwCurrentState==SERVICE_START_PENDING) ||
		(ssStatus.dwCurrentState==SERVICE_STOP_PENDING) );

	if ( ControlService (hService,SERVICE_CONTROL_STOP,&ssStatus) )
	{
		int iTime = 0;
		do
		{
			if ( iTime++ > 5 )
				break;
			Sleep(500);
			QueryServiceStatus (hService,&ssStatus);
		} while (ssStatus.dwCurrentState != SERVICE_STOPPED );
	}
	CloseServiceHandle (hService);
	CloseServiceHandle (hSCManager);

	m_bServiceRun = FALSE;
}

void CMainFrame::OnUpdateStartAgent(CCmdUI *pCmdUI)
{
	if(m_bServiceRun)
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnUpdateStopAgent(CCmdUI * pCmdUI)
{
	if(!m_bServiceRun)
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(TRUE);
	}
}

//imachine added 2010.08.24, set configuration item status
void CMainFrame::OnUpdateConfiguration(CCmdUI * pCmdUI)
{
	if(!m_bOmronCommand)
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(TRUE);
	}
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.lpszClass = AfxRegisterWndClass(0);
	cs.lpszName	= _T("ShutdownAgent");

	return TRUE;
}


#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

