// MainFrm.h : interface of the CMainFrame class
//
#ifndef      __MAINFRAME_H__
#define	     __MAINFRAME_H__

#include "..\Protocol.h"
#include "..\ConfigFile.h"

#define WM_MY_TRAY_NOTIFICATION		WM_USER+0x1000
#define WM_USER_TRAY                WM_USER+0x1001
#define WM_NOTIFYICON				WM_USER+0x1002

//#define SZ_SW_PRODNAME      "Simple Shutdown Software"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();
protected: 
	DECLARE_DYNAMIC(CMainFrame)

public:
	virtual ~CMainFrame();

public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

	BOOL ChangeICONStatus(DWORD dwMsg);
	UINT GetStatusStringID(BYTE byStatus);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	CBitmap	m_bitmap;
	HICON m_hTrayIcon;
	CMenu m_menuTray;
	CMenu *m_pMenuTray;
	BOOL m_bServiceRun;
	BOOL m_bOmronCommand;	//imachine added 2010.08.24, set configuration item status
private:
	BOOL m_bICONExist;

public:
	BOOL m_bTrayCreated;
	NOTIFYICONDATA m_TrayStruct;
	SHUTDOWN_AGENT	m_AMData;
	SHUTDOWNPARAM m_ShutdownParam;

// Generated message map functions
protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnClose();
	afx_msg void OnTrayExit();
	afx_msg void OnTrayConfig();
	afx_msg void OnTrayAbout();
	afx_msg void OnTrayStart();
	afx_msg void OnTrayStop();
	afx_msg void OnUpdateStartAgent(CCmdUI *pCmdUI);
	afx_msg void OnUpdateStopAgent(CCmdUI *pCmdUI);
	afx_msg void OnUpdateConfiguration(CCmdUI *pCmdUI);	//imachine added 2010.08.24, set configuration item status
	DECLARE_MESSAGE_MAP()
};
#endif

