// omronctl.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "../ConfigFile.h"
#include "../ConfigFile.cpp"

CShareMem	shm;
//Colin@2010-12-15 modify
#define ERR_AGENTSTOP	501
#define ERR_COMLST		502
#define ERR_COMMEXEC	503
#define ERR_TIMEWRONG	504
#define WARR_REATART_TIME 505
#define ERR_OTHER	506




int DoCommandSNRM(int nOperationSign, int ParamO, int error);
int DoErrorSNRM(int nOperationSign, int ParamO, int error);

void ShowHelp();
BOOL CheckTimeFormat(const char *pszTime);
int GetInpuId(const char *szInput);
time_t StructIntoTime(int nYear, int nMoon, int nDay, int nHour, int nMin, int nSec);
int GetLaterTimeMin(const char *pszTime);
int TestCommandExec();
void PrintWarningInfo();
void PrintSuccInfo();



int main(int argc, char* argv[])
{
	int ret = 0;
	int i, l;
	char s[32];
	int ParamO = 0;
	HANDLE hMutex;
	char szArg[MAX_LINELENGTH] = {0};
	int nTimeMinLater = 0;
	SHM_DATA_OMRON shmdata;
	//colin added for read config file
	SHUTDOWNPARAM ShutdownParam;
	CConfigFile inifile;


	signal(SIGINT, SIG_IGN); /* Ignore Ctrl-C */

	if (!(hMutex = CreateMutex(NULL, TRUE, "__OMRONCTL__")) || ERROR_ALREADY_EXISTS == GetLastError()) {
		return ERR_OTHER;
	}

	if (argc == 1)
	{
		if ( !TestCommandExec() )
		{
			int tmp = DoCommandSNRM(UPS_STATUS_SD_OS_UPS, 0, 0);
			if ( tmp != ERR_OTHER && tmp != ERR_AGENTSTOP && tmp != ERR_COMLST)
			{
				PrintSuccInfo();
				return 0;
			}
			else 
				ret = tmp;
		}
		else {
			PrintWarningInfo();
			DoErrorSNRM(0, 0, ERR_COMMEXEC);//Colin@2010-12-14 added
			ret = ERR_COMMEXEC;
		}
		return ret;
	}
	else if ((argc == 3) &&	strcmp( argv[1], "-O") == 0 && CheckTimeFormat( argv[2] )) //imachine modified 2010.07.21
	{
		nTimeMinLater = GetLaterTimeMin( argv[2] );

		if(nTimeMinLater < 0)
		{
			printf("     Time setting is Wrong.\n");
			DoErrorSNRM(0, 0, ERR_TIMEWRONG); //Colin@2010-12-14 added

			ret = ERR_TIMEWRONG;
			return ret;
		}		

		if (nTimeMinLater < 10) //jimpu modified 2010.11.09
		{
			if(nTimeMinLater >= 0)
			{
				if ( !TestCommandExec() )
				{	int tmp = DoCommandSNRM(UPS_STATUS_ONLY_SD_OS, 0, 0);
					if ( tmp != ERR_OTHER && tmp != ERR_AGENTSTOP && tmp != ERR_COMLST)//jimpu modified 2010.11.09
					{
						printf("    Only restart OS, can't restart UPS.\n");//jimpu modified 2010.11.09
						//PrintWarningInfo();
						return 0;
					}
					else 
						ret = tmp;
				}
				else
				{
					PrintWarningInfo();
					DoErrorSNRM(0, 0, ERR_COMMEXEC);//Colin@2010-12-14 added
					ret = ERR_COMMEXEC;
				}
			}
			return ret;

		}
		else
		{
			if (nTimeMinLater <= 99999) {
				inifile.GetShutdownParameter(&ShutdownParam);
				int realshutdowntime = (ShutdownParam.uShutdownNeedTime + ShutdownParam.uCommandDelayTime)/60;
				if ((nTimeMinLater - realshutdowntime) >= 0) {
					if ( !TestCommandExec() )
					{	int tmp = DoCommandSNRM(UPS_STATUS_SD_OS_RESTART_LATER, nTimeMinLater, 0);
						if (tmp != ERR_OTHER && tmp != ERR_AGENTSTOP && tmp != ERR_COMLST)
						{
							PrintSuccInfo();
							return 0;
						}
						else
							ret = tmp;
					}
					else {
						PrintWarningInfo();
						DoErrorSNRM(0, 0, ERR_COMMEXEC);//Colin@2010-12-14 added
						ret = ERR_COMMEXEC;
					}
				}
				else {
					printf("\n");
					printf("    Can't do the schedule shutdown action.\n");
				
					DoErrorSNRM(0, 0, WARR_REATART_TIME);
					return WARR_REATART_TIME;
				
				}
			}
			else {	
				printf("\n");
				printf("Time setting is Wrong.\n\n");
				
				DoErrorSNRM(0, 0, ERR_TIMEWRONG);//Colin@2011-1-26 added
				ret = ERR_TIMEWRONG;
			}

		}
		return ret;
	}
	else if ((argc == 3) && strcmp(argv[1], "/f") == 0 &&strcmp(argv[2], "/r") == 0)
	{
		if ( !TestCommandExec() )
		{	
			int tmp = DoCommandSNRM(UPS_STATUS_ONLY_SD_OS, 0, 0);
			if ( tmp != ERR_OTHER && tmp != ERR_AGENTSTOP && tmp != ERR_COMLST)
			{
				PrintSuccInfo();
				return 0;
			}
			else 
				ret = tmp;
		}
		else {
			PrintWarningInfo();
			DoErrorSNRM(0, 0, ERR_COMMEXEC);//Colin@2010-12-14 added
			ret = ERR_COMMEXEC;
		}
		return ret;
	}
	else if (!((argc == 2) && strcmp(argv[1], "/?") == 0 ))
	{
		printf("\n");
		printf("Parameter Format is Wrong.\n\n");

		ret = ERR_TIMEWRONG;
	}

	ShowHelp();
	DoErrorSNRM(0, 0, ret);
	return ret;
}

BOOL CheckTimeFormat(const char *pszTime)
{
	char szTemp[512];

	char szYear[4 + 1] = {0};
	char szMon[2 + 1] = {0};
	char szDay[2 + 1] = {0};
	char szHour[2 + 1] = {0};
	char szMin[2 + 1] = {0};

	int nYear = 0;
	int nMon = 0;
	int nDay = 0;
	int nHour = 0;
	int nMin = 0;

	int i = 0;

	memset(szTemp, 0x00, sizeof(szTemp));
	strcpy(szTemp, pszTime);

	if (strlen(szTemp) != 16)
	{
		return FALSE;
	}

	if ( szTemp[4] != '/' || szTemp[7] != '/' || szTemp[10] != '.' || szTemp[13] != ':' )
	{
		return FALSE;
	}

	for (i = 0; i < 4; i ++)
		szYear[i] = szTemp[i];
	for (i = 0; i < 2; i ++)
	{
		szMon[i] = szTemp[i + 5];
		szDay[i] = szTemp[i + 8];
		szHour[i] = szTemp[i + 11];
		szMin[i] = szTemp[i + 14];
	}
	nYear = GetInpuId(szYear);
	nMon = GetInpuId(szMon);
	nDay = GetInpuId(szDay);
	nHour = GetInpuId(szHour);
	nMin = GetInpuId(szMin);

	if (nYear < 1970 || nYear > 2100 ||
			nMon < 1 || nMon > 12 ||
			nDay < 1 || nDay > 31 ||
			nHour < 0 || nHour >= 24 || 
			nMin < 0 || nMin > 59)
	{
		return FALSE;
	}
	switch(nMon)
	{
		case 1:
		case 3:
		case 5:
		case 7:
		case 8:
		case 10:
		case 12:
			break;
		default:
			if (nDay > 30)
			{
				return FALSE;
			}
			break;
	}

	return TRUE;
}


int GetLaterTimeMin(const char *pszTime)
{
	char szTemp[512];

	char szYear[4 + 1] = {0};
	char szMon[2 + 1] = {0};
	char szDay[2 + 1] = {0};
	char szHour[2 + 1] = {0};
	char szMin[2 + 1] = {0};

	int nYear = 0;
	int nMon = 0;
	int nDay = 0;
	int nHour = 0;
	int nMin = 0;

	int i = 0;

	time_t tNow;

	time_t  tTemp;
	int nTimeLater = 0;


	memset(szTemp, 0x00, sizeof(szTemp));
	strcpy(szTemp, pszTime);

	if (strlen(szTemp) != 16)
	{
		return 0;
	}

	if ( szTemp[4] != '/' || szTemp[7] != '/' || szTemp[10] != '.' || szTemp[13] != ':' )
	{
		return FALSE;
	}

	for (i = 0; i < 4; i ++)
		szYear[i] = szTemp[i];
	for (i = 0; i < 2; i ++)
	{
		szMon[i] = szTemp[i + 5];
		szDay[i] = szTemp[i + 8];
		szHour[i] = szTemp[i + 11];
		szMin[i] = szTemp[i + 14];
	}
	nYear = GetInpuId(szYear);
	nMon = GetInpuId(szMon);
	nDay = GetInpuId(szDay);
	nHour = GetInpuId(szHour);
	nMin = GetInpuId(szMin);


	//imachine modified 2010.07.15
	//tNow = time(NULL);
	//tTemp = StructIntoTime(nYear, nMon, nDay, nHour, nMin, 0);
	//nTimeLater = tTemp - tNow;

	CTime	ctNow( time(NULL) );
	CTime	ctUserTime ( nYear, nMon, nDay, nHour, nMin, 0 );
	CTimeSpan	ctTimeInterval = ctUserTime - ctNow;

	nTimeLater = ctTimeInterval.GetTotalSeconds();
	//	printf("nTimeLater=%d\n",nTimeLater);
	if(nTimeLater < 0) //tom modify on 2010.11.11
		return -1;
#if 0
	//if (nTimeLater > 15 * 60)
	if (nTimeLater > 10 * 60)//jimpu modified 2010.11.09
	{
		return nTimeLater ;
	}
#endif	
	return nTimeLater/60 ;

}


time_t StructIntoTime(int nYear, int nMoon, int nDay, int nHour, int nMin, int nSec)
{
	struct tm tTempTime;

	memset(&tTempTime, 0, sizeof(struct tm));
	tTempTime.tm_sec = nSec;
	tTempTime.tm_min = nMin;
	tTempTime.tm_hour = nHour;
	tTempTime.tm_mday = nDay;
	tTempTime.tm_mon = nMoon-1; /* range 0 to 11 */
	tTempTime.tm_year = nYear-1900; /* since 1900 */
	tTempTime.tm_isdst = 1;	// imachine added 2010.07.14

	return mktime(&tTempTime);
}

int GetInpuId(const char *szInput)
{
	int nInput = 0;
	char szBuff[MAX_PATH];
	char szTemp[512];
	BOOL bFirstNotZero = FALSE;
	int nFirstNotZero = 0;
	int i = 0;
	nInput = atoi(szInput);

	memset(szTemp, 0x00, sizeof(szTemp));
	for (i = 0; i < strlen(szInput); i ++)
	{
		if (!bFirstNotZero && szInput[i] != '0')
		{
			bFirstNotZero = TRUE;
			nFirstNotZero = i;
		}
		if (bFirstNotZero)
		{
			szTemp[i - nFirstNotZero] = szInput[i];
		}
	}
	if (!bFirstNotZero)
	{
		szTemp[0] = '0';
	}

	memset(szBuff, 0, MAX_PATH);
	sprintf(szBuff, "%d", nInput);
	if (strcmp(szTemp, szBuff) != 0 || nInput < 0)
		nInput = -1;
	return nInput;
}

/* Send S<n>R<m> comand for JP1. <m> is set by ParamO [seconds] */
/* Colin modified @2010-12-4 add a parameter for error number */
int DoCommandSNRM(int nOperationSign, int ParamO, int error)
{
	BOOL	bRet;
	int		ret = 0;
	SHM_DATA_OMRON shmdata;

	bRet = shm.InitializeMem(1, sizeof(SHM_DATA_OMRON), OMRONDATAMAPPINGNAME, OMRONSYNCFILEMAPPING, FALSE);
	if (bRet) 
	{
		if (shm.Lock(500)) 
		{
			memset(&shmdata, 0x00, sizeof(SHM_DATA_OMRON));
			if (!shm.GetData(0, &shmdata, sizeof(SHM_DATA_OMRON)))
			{
				shm.Unlock();
				return ERR_OTHER;
			}
			if (ERR_COMLST == shmdata.uPara4) { // Colin added for ups communication lost
				
				memset(&shmdata, 0x00, sizeof(SHM_DATA_OMRON));
				if (0 == error) {
					shmdata.uCmd   = nOperationSign;
					shmdata.uPara1 = 0;
					shmdata.uPara2 = ParamO;
					shmdata.uPara4 = ERR_COMLST;
				}else {
					shmdata.uPara3 = error;
					shmdata.uPara4 = ERR_COMLST;
				}

				if (!shm.SetData(0, &shmdata, sizeof(SHM_DATA_OMRON)))
				{
					shm.Unlock();
					return  ERR_OTHER;
				} 

				shm.Unlock();
				
				printf("\n    SimpleShutdown communication UPS lost.\n");
				printf("    Please check the UPS is connected.\n\n");

				return ERR_COMLST;
			} 
			else {

				memset(&shmdata, 0x00, sizeof(SHM_DATA_OMRON));
				if (0 == error) { 	//colin added @2010-12-14
					shmdata.uCmd   = nOperationSign;
					shmdata.uPara1 = 0;		/* n: 0 then use simple shutdown default */
					shmdata.uPara2 = ParamO;	/* m: 0 then not-reboot (= Use S<n> comand) */
				}else {
					shmdata.uCmd   = nOperationSign;
					shmdata.uPara1 = 0;		/* n: 0 then use simple shutdown default */
					shmdata.uPara2 = ParamO;	/* m: 0 then not-reboot (= Use S<n> comand) */
					shmdata.uPara3 = error;
				}

				if (!shm.SetData(0, &shmdata, sizeof(SHM_DATA_OMRON))) 
				{
					shm.Unlock();
					return  ERR_OTHER;
				} 
				/* This shmdata is read by CUpsCheck::ReadMemData()@UpsCheck.cpp */

				shm.Unlock();
			}
		}
		else 
		{
			printf("\n    Can not communicate with Simple Shutdown Service.\n");
			printf("    Please check the service is running.\n\n");
			return ERR_AGENTSTOP;
		}
		//colin added for receive communication lost status		
	}
	else 
	{
		ret = ERR_OTHER;
	}

	return ret;
}

//Colin@2010-12-22 added for report return value to SSD
int DoErrorSNRM(int nOperationSign, int ParamO, int error)
{
	BOOL	bRet;
	int		ret = 0;
	SHM_DATA_OMRON shmdata;

	bRet = shm.InitializeMem(1, sizeof(SHM_DATA_OMRON), OMRONDATAMAPPINGNAME, OMRONSYNCFILEMAPPING, FALSE);
	if (bRet) 
	{
		if (shm.Lock(500)) 
		{
			memset(&shmdata, 0x00, sizeof(SHM_DATA_OMRON));
			if (!shm.GetData(0, &shmdata, sizeof(SHM_DATA_OMRON)))
			{
				return ERR_OTHER;
			}
			if (ERR_COMLST == shmdata.uPara4) {
				memset(&shmdata, 0x00, sizeof(SHM_DATA_OMRON));
			
				if (0 == error) { 	//colin added @2010-12-14
					shmdata.uCmd   = nOperationSign;
					shmdata.uPara1 = 0;		/* n: 0 then use simple shutdown default */
					shmdata.uPara2 = ParamO;	/* m: 0 then not-reboot (= Use S<n> comand) */
					shmdata.uPara4 = ERR_COMLST;
				}else {
					shmdata.uPara3 = error;
					shmdata.uPara4 = ERR_COMLST;
				}

				if (!shm.SetData(0, &shmdata, sizeof(SHM_DATA_OMRON))) 
				{
					ret = ERR_OTHER;
				} 
				/* This shmdata is read by CUpsCheck::ReadMemData()@UpsCheck.cpp */
				shm.Unlock();
			}
			else {
				memset(&shmdata, 0x00, sizeof(SHM_DATA_OMRON));
				if (0 == error) { 	//colin added @2010-12-14
					shmdata.uCmd   = nOperationSign;
					shmdata.uPara1 = 0;		/* n: 0 then use simple shutdown default */
					shmdata.uPara2 = ParamO;	/* m: 0 then not-reboot (= Use S<n> comand) */
				}else {
					shmdata.uPara3 = error;
				}

				if (!shm.SetData(0, &shmdata, sizeof(SHM_DATA_OMRON))) 
				{
					ret = ERR_OTHER;
				} 
				/* This shmdata is read by CUpsCheck::ReadMemData()@UpsCheck.cpp */
				shm.Unlock();
			}
		}
		else 
		{
			printf("\n    Can not communicate with Simple Shutdown Service.\n");
			printf("    Please check the service is running.\n\n");
			ret = ERR_AGENTSTOP;
		}
	}
	else 
	{
		ret = ERR_OTHER;
	}

	return ret;
}
//end Colin added

void ShowHelp()
{
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),FOREGROUND_RED);
	printf("    Simple Shutdown 2.51 (Release Date:2018-03-05)\n");
	printf("    2011 OMRON Corporation and FIT Inc.\n");
	printf("    All rights Reserved.\n\n\n");
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),0x0007);
	printf("    HELP:\n");
	printf("    1, omronctl.exe (No return value)\n");
	printf("       <Function>\n");
	printf("          Shutdown OS and UPS.\n\n");

	printf("    2, omronctl.exe -O YYYY/MM/DD.hh:mm\n");
	printf("       <Function>\n");
	printf("          Shutdown OS and UPS and then restart UPS at the set time.\n");
	printf("       <Note>\n");
	printf("          The set time to restart UPS should be at least 10 Min later than the current time, or the UPS will not restart.\n\n");

	printf("    3, omronctl.exe /f /r\n");
	printf("       <Function>\n");
	printf("          Run this command and OS shutdown and restart system.\n\n");
	return ;
}


int TestCommandExec()
{
	HANDLE		hUpdateOmronCtrl = NULL;
	hUpdateOmronCtrl = OpenEvent(EVENT_ALL_ACCESS, FALSE, UPDATE_OMRON_OPTION );
	if ( hUpdateOmronCtrl != NULL )
	{
		if ( WaitForSingleObject( hUpdateOmronCtrl, 0 ) == WAIT_OBJECT_0 )
		{
			return 1;
		}
	}

	return 0;
}


void PrintWarningInfo()
{
	printf("\n    The Command is executing.\n");
}


void PrintSuccInfo()//jimpu modified 2010.11.10
{
	printf("\n    The Command Successful.\n");
}

//jimpu modified 2010.11.10


