// UPSDLL.h: interface for the CUPSDLL class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_UPSDLL_H__E31F0B91_92A3_4BD4_A61E_55911E9F54E7__INCLUDED_)
#define AFX_UPSDLL_H__E31F0B91_92A3_4BD4_A61E_55911E9F54E7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ups.h"
#include "ShareMemUPSCmd.h"
#include "..\ConfigFile.h"
#include "EventRes.h" //Colin@2010-12-14  added 


#define THREAD_DELAY					300



class CUPSDLL  
{
public:
	CUPSDLL ();
	virtual ~CUPSDLL();

private:
	
	BOOL		m_bRunScan;
	HWND		m_hAgentWnd;

	USBDNAME		m_UsbDevice;

	OVERLAPPED		m_overlapped;
	HANDLE			m_hNamedPipe;
	HANDLE			m_hConnectClient;
	PIPE_DATA		m_szPipeCmd;
	BOOL			m_bConnect;
	HANDLE			m_hScanUpsThread;
	HANDLE			m_hStopAgent;
	HANDLE			m_hScanThread;
	HANDLE			m_hPipEvent;
public:
	BOOL			m_bSMCmdManuallyInited;
	CShareMem		m_ShareMem;
	SHM_DATA		m_SHMData;
	HANDLE			m_hUpdateConfigForComm;
	CConfigFile		m_fileConfig;
	SHUTDOWNPARAM	m_SDParam;
	SHUTDOWNPARAM	m_oldSDParam;

	//imachine added 2010.07.12
	HANDLE			m_hUpdateConnection;	
	HANDLE			m_hUPSCMDSNEvent;

	//imachine added 2010.08.24
	HANDLE			m_hUpdateOmronCtrl;	
public:
	BOOL		Initialize();
	void		Terminate();

private:
	BOOL		RemoveUPSObject();
	BOOL		WaitPipeServ();
	BOOL		ReadNamedPipe();

public:
	friend DWORD WINAPI ScanUpsThread(LPVOID);
	friend DWORD WINAPI CommitWithUPSThread(LPVOID);
	void	UpdateConfigFile();
	CUPS		m_upsObject;
protected:
	CShareMem	m_cSHMForOmron;
	int			DealWithSHMForOmron();
	
};

#endif // !defined(AFX_UPSDLL_H__E31F0B91_92A3_4BD4_A61E_55911E9F54E7__INCLUDED_)
