// UpsCheck.h: interface for the CUpsCheck class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_UPSCHECK_H__11C5CEE6_75BE_4327_8123_FFA440DAD4C7__INCLUDED_)
#define AFX_UPSCHECK_H__11C5CEE6_75BE_4327_8123_FFA440DAD4C7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <Windows.h>
#include "..\MessageDll\EventFile.h"
#include "ShareMemUPSCmd.h"
#include "UPSDLL.h"
#include "..\ConfigFile.h"
#include "..\Protocol.h"

#define NO_ERR				0
#define WM_COMMEND			WM_USER+0x100

#define SHUTDOWN_NONE			0
#define SHUTDOWN_UNFORCE		1
#define SHUTDOWN_FORCE			2

//star add 20090115
#define TIME_RANGE				3

#define TEMP_FILE "TempFile"

class CUpsCheck  
{
public:
	CUpsCheck();
	virtual ~CUpsCheck();
	
public:
	CShareMem 		m_pReadMem;
	SHM_DATA		m_SHMData;
	SHUTDOWN_AGENT	m_ShutdownAgent;
	SHUTDOWNPARAM	m_SDParam;
	CConfigFile		m_fileConfig;
	CUPSDLL *		m_upsData;

	BOOL		m_bSMUPSCmdInited;
	BOOL		m_bACFail;
	BOOL		m_bBatteryLow;
	time_t		m_tACFailStart;
	int			m_iShutdownStep;
	time_t		m_tStartShutdownTime;
	BOOL		m_bConfigExist;

private:
	HANDLE			m_hNamedPipe;
	HANDLE			m_hConnectClient;
	OVERLAPPED		m_overlapped;

	PIPE_DATA		m_PipeData;
	HANDLE			m_hMutex;
	HANDLE			m_hFileMap;
	HANDLE			m_hUpdateConfig;
	HANDLE			m_hUpdatePip;
	DWORD			m_dwUPSStatus;
	PSID			m_pEveryoneSID;
	PSID			m_pAdminSID;
	PACL					m_pACL;
	PSECURITY_DESCRIPTOR	m_pSD;
	SECURITY_ATTRIBUTES		m_sa;
	BOOL			m_bWrited;
	BOOL			m_nWinVista;

	BOOL		m_bFirstCommEst;
	BOOL		m_bFirstACFail;
	BOOL		m_bFirstBattLow;

public:
	BOOL	Initialize();
	void	SimpleSDLogEvent(WORD wType, DWORD dwID,UINT strResID);
	int		CheckEvent();
	BOOL	DoDelay();
	BOOL	DoShutdownLogic();
	void	UpdateConfigFile();
	int		GetOSVersion_Vista();

private:
	int		WriteEventLog(char *pszBufMes);
	BOOL	ExecuteExternCmd();

	BOOL	CreateMyNamedPipe();
	BOOL	ConnectPipeClient();
	BOOL	WritePipeCmd();	

	BOOL	ReadMemData();
	HANDLE	InitialShareMemory();
	HANDLE	InitialMutex();
	BOOL	SetSecuAttr();
	void	FreeRes();
	HANDLE	InitialConfigShareMemory();
	HANDLE	InitialConfigMutex();

private:
	int		CheckACFail();
	int		CheckBattLow();
	BOOL	ModifyUPSData(SHUTDOWN_AGENT &shutdownAgent);
	BOOL	GetTokenByName(HANDLE &hToken);

};

#endif // !defined(AFX_UPSCHECK_H__11C5CEE6_75BE_4327_8123_FFA440DAD4C7__INCLUDED_)
